﻿namespace Josso.Agent.Lib
{
    /// <summary>
    /// The base agent contains the josso object that let you access to the webservice
    /// of the josso server
    /// </summary>
    public class ZjsBaseAgent
    {
        /// <summary>
        /// the name of the cookie
        /// </summary>
        public const string COOKIE_NAME = "JOSSO_SESSIONID";

        /// <summary>
        /// the josso proxy
        /// </summary>
        private ZjsJosso _josso;

        /// <summary>
        /// the constructor with the address of the josso proxy
        /// </summary>
        /// <param name="gatewayUrl"></param>
        public ZjsBaseAgent(string gatewayUrl)
        {
            _josso = new ZjsJosso(gatewayUrl);
        }

        /// <summary>
        /// the constructor with the address of the josso proxy
        /// </summary>
        /// <param name="gatewayUrl"></param>
        /// <param name="disableSSL">disable the SSL</param>
        public ZjsBaseAgent(string gatewayUrl, bool disableSSL)
            : this(gatewayUrl)
        {
            _josso.DisableCertificate = disableSSL;
        }

        /// <summary>
        /// get the josso proxy or set the proxy (in order to test)
        /// </summary>
        internal ZjsJosso Josso
        {
            get
            {
                return _josso;
            }

            set
            {
                _josso = value;
            }
        }
    }
}